InternetShopWebProjectSolution/InternetShopWebProject/Controllers/CardInfoController.cs
using InternetShopWebProject.Common.Models;
using InternetShopWebProject.DAL.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Microsoft.AspNet.Identity;
using Unity.Attributes;
using System.Web.Mvc;
using InternetShopWebProject.Common.Entities;
using InternetShopWebProject.Models;
using InternetShopWebProject.CookiesManager;

namespace InternetShopWebProject.Controllers
{
    public class CardInfoController : Controller
    {
        [Dependency]
        public IStickerRepository _stickerRepos { get; set; }
        [Dependency]
        public ICommentsRepository _commentsRepository { get; set; }

        public ActionResult Index()
        {
            return RedirectToAction("Index", "Home");
        }

        public ActionResult Product(Guid id, bool wasCommentAdd = false)
        {
            var model = new CardInfo();
            model.Id = id;
            model.Sticker = new ProductModel().ToProductModel(_stickerRepos.StickerInfo(id));
            model.Comments = _commentsRepository.GetComments(id).OrderByDescending(x => x.CreatedDate);
            model.InBag = ShoppingCart.IsInBag(id);
            model.NewCommentAdded = wasCommentAdd;
            LastViewed.Add(id);
            return View(model);
        }

        public ActionResult NewComment(CardInfo cardInfo)
        {
            var userId = User.Identity.GetUserId();
            _commentsRepository.NewComment(new ProductComment
            {
                CreatedDate = DateTime.Now,
                Id = Guid.NewGuid(),
                ProductId = cardInfo.Id,
                Text = cardInfo.NewComment.Text,
                UserName = cardInfo.NewComment.Name != null ? cardInfo.NewComment.Name : User.Identity.Name,
                UserId = userId != null ? new Guid(userId) : (Guid?)null
            });
            return RedirectToAction("Product", new { id = cardInfo.Id, wasCommentAdd = true });
        }
    }
}

InternetShopWebProjectSolution/InternetShopWebProject/Controllers/ShoppingBagController.cs
using InternetShopWebProject.Common.Models;
using InternetShopWebProject.CookiesManager;
using InternetShopWebProject.DAL.Repository;
using InternetShopWebProject.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Unity.Attributes;

namespace InternetShopWebProject.Controllers
{
    public class ShoppingBagController : Controller
    {
        [Dependency]
        public IStickerRepository _stickerRepos { get; set; }

        public ActionResult Index()
        {
            var stickerIdsInBag = ShoppingCart.Products;
            var stickers = _stickerRepos.StickersById(stickerIdsInBag);
            var model = new ShoppingBagModel(stickers);
            return View(model);
        }

        public ActionResult AddToShoppingBag(Guid id, string returnUrl)
        {
            ShoppingCart.Add(id);
            return Redirect(returnUrl);
        }

        public ActionResult RemoveFromShoppingBag(Guid id, string returnUrl)
        {
            ShoppingCart.Remove(id);
            return Redirect(returnUrl);
        }

        public ActionResult ConfirmOrder(ShoppingBagModel model)
        {
            
            return View("Index", model);
        }

        public ActionResult RemoveProduct(ShoppingBagModel model)
        {

            return View("Index", model);
        }
    }
}

InternetShopWebProjectSolution/InternetShopWebProject/Views/CardInfo/Product.cshtml
@model InternetShopWebProject.Common.Models.CardInfo

@Html.HiddenFor(m => m.Id)

<link href="~/Content/Card-info.css" rel="stylesheet" type="text/css" />

<div>
    <div class="info-content">
        <div class="image-place">
            <img src="~/Content/Image/@Model.Sticker.Image" />
        </div>
        <div class="info-place">
            <div>
                <h4>@Model.Sticker.Name</h4>
            </div>
            <div>
                @if (Model.Sticker.Available)
                {
                    <h6 class="text-success">Є в наявності</h6>
                }
                else
                {
                    <h6 class="text-danger">Немає в наявності</h6>
                }
            </div>
            <hr />
            <div style="margin-top:20px">
                <h4>@Model.Sticker.Price</h4>

                @if (Model.InBag)
                {
                    @Html.ActionLink("В корзині", "RemoveFromShoppingBag", "ShoppingBag", new { id = Model.Id, returnUrl = Request.Url }, new { @class = "btn btn-outline-success", id = Model.Id })
                }
                else
                {
                    @Html.ActionLink("Купити", "AddToShoppingBag", "ShoppingBag", new { id = Model.Id, returnUrl = Request.Url }, new { @class = "btn btn-outline-secondary", id = Model.Id })
                }
            </div>
            <h5 style="margin-top:10px">@Model.Sticker.Size</h5>
            <hr />
            @Html.Partial("_OrderInfoPartial")
        </div>

    </div>

    <div class="comments-area">
        <ul class="nav nav-tabs" id="DescribeAndCommentTab" role="tablist">
            <li class="nav-item">
                <a class="nav-link @(!Model.NewCommentAdded ? "active" : "")" id="describe-tab" data-toggle="tab" href="#describe" role="tab" aria-controls="describe" aria-selected="true">
                    Опис
                </a>
            </li>
            <li class="nav-item">
                <a class="nav-link @(Model.NewCommentAdded ? "active" : "")" id="comment-tab" data-toggle="tab" href="#comment" role="tab" aria-controls="comment" aria-selected="false">
                    Відгуки
                </a>
            </li>
        </ul>
        <div class="tab-content" id="DescribeAndCommentTabContent">
            <div class="tab-pane fade @(!Model.NewCommentAdded ? "show active" : "")" id="describe" role="tabpanel" aria-labelledby="describe">
                Стикер изготовлен из высококачественной плёнки. Покрыт ламинацией с УФ защитой изображения от выцветания, намокания и механических повреждений. Ламинация тонкая и мягкая. Качество печати 4880 dpi. Продукция подходит для нанесения на различные поверхности такие как: металл, пластик, стекло, плотную кожу. Отлично клеится на ноутбук, велосипед, автомобиль, гитару, байк, шлем, телефон, плеер, скейтборд, сноуборд и т.д. Снимается не оставляя следов на поверхности.
            </div>
            <div class="tab-pane fade @(Model.NewCommentAdded ? "show active" : "")" id="comment" role="tabpanel" aria-labelledby="comment">
                <div class="product-commments">
                    @foreach (var coment in Model.Comments)
                    {
                        @Html.Partial("_CommentPartial", coment)
                    }
                </div>
                @Html.Partial("_NewCommentPartial", Model)
            </div>
        </div>

    </div>
</div>


@if (Model.NewCommentAdded)
{
    <script>
        window.addEventListener('DOMContentLoaded', (event) => {
            window.scrollTo(0, document.body.scrollHeight);
        });
    </script>
}

InternetShopWebProjectSolution/InternetShopWebProject/Views/CardInfo/_CommentPartial.cshtml
@model InternetShopWebProject.Common.Entities.ProductComment

<div class="comment card">
  <div class="logo">
    <img src="~/Content/Image/user logo.png"/>
  </div>
  <div class="coment-content">
    <div class="comment-info">
      <h6>@Model.UserName</h6>
      <div>@Model.CreatedDate.ToShortDateString()</div>
    </div>
    <div class="comment-value">
      @Model.Text
    </div>
  </div>
</div>

InternetShopWebProjectSolution/InternetShopWebProject/Views/CardInfo/_NewCommentPartial.cshtml
@model InternetShopWebProject.Common.Models.CardInfo
@{ bool isRegistered = System.Web.HttpContext.Current.User.Identity.IsAuthenticated; }

@using (Html.BeginForm("NewComment", "CardInfo", FormMethod.Post))
{
  @Html.HiddenFor(m => m.Id)
  <div class="new-comments">
    @if (!isRegistered)
    {
      <h5>Имя</h5>
      @Html.TextBoxFor((m => m.NewComment.Name), new { required = "required", @class = "form-control" })
    }

    <h5>Ваш коментарий</h5>
    @Html.TextAreaFor((m => m.NewComment.Text), new { required = "required", @class = "form-control" })
    <button type="submit" class="btn btn-primary">Оставить</button>
  </div>
}

InternetShopWebProjectSolution/InternetShopWebProject/Views/CardInfo/_OrderInfoPartial.cshtml
<ul class="nav nav-tabs" id="OrderTab" role="tablist" style="margin-top:30px">
  <li class="nav-item">
    <a class="nav-link active" id="home-tab" data-toggle="tab" href="#home" role="tab" aria-controls="home" aria-selected="true">Доставка</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="profile-tab" data-toggle="tab" href="#profile" role="tab" aria-controls="profile" aria-selected="false">Оплата</a>
  </li>
  <li class="nav-item">
    <a class="nav-link" id="contact-tab" data-toggle="tab" href="#contact" role="tab" aria-controls="contact" aria-selected="false">Гарантия</a>
  </li>
</ul>
<div class="tab-content" id="myTabContent">
  <div class="tab-pane fade show active" id="home" role="tabpanel" aria-labelledby="home-tab">
    <ul>
      <li>
        Доставка по Україні — 40 грн.
      </li>
      <li>
        Зворотній платіж + 24 грн. до доставки.
      </li>
    </ul>
  </div>
  <div class="tab-pane fade" id="profile" role="tabpanel" aria-labelledby="profile-tab">
    <ul>
      <li>
        Готівка при отриманні.
      </li>
      <li>
        Кредитною картою в privat24, LiqPay.
      </li>
      <li>
        Через касу або термінал обслуговування Приватбанк.
      </li>
    </ul>
  </div>
  <div class="tab-pane fade" id="contact" role="tabpanel" aria-labelledby="contact-tab">
    <ul>
      <li>
        Гарантія від виробника 12 місяців
      </li>
    </ul>
  </div>
</div>